import 'package:json_annotation/json_annotation.dart';

part 'AddressModel.g.dart';

//flutter packages pub run build_runner build --delete-conflicting-outputs
@JsonSerializable()
class AddressModel {
  final int id;
  final String description;
  final int number;
  final double lat;
  final double lng;

  AddressModel({
    required this.id,
    required this.description,
    required this.number,
    required this.lat,
    required this.lng,
  });

  factory AddressModel.fromJson(Map<String, dynamic> json) =>
      _$AddressModelFromJson(json);
  Map<String, dynamic> toJson() => _$AddressModelToJson(this);

  @override
  String toString() {
    return "${this.description}, ${this.number}";
  }
}

class PartialAddress {
  final int id;

  PartialAddress(this.id);
}
