import 'dart:math';

import 'package:apus_drones_mobile/models/CreatePartner.dart';
import 'package:apus_drones_mobile/screens/LoginScreen.dart';
import 'package:apus_drones_mobile/services/PartnerService.dart';
import 'package:flutter/material.dart';

class CreatePartnerScreen extends StatefulWidget {
  const CreatePartnerScreen({Key? key}) : super(key: key);

  @override
  _CreatePartnerScreenState createState() => _CreatePartnerScreenState();
}

class _CreatePartnerScreenState extends State<CreatePartnerScreen> {
  late CreatePartner Partner;
  TextEditingController nameController = TextEditingController();
  TextEditingController CPFController = TextEditingController();
  TextEditingController passwordController = TextEditingController();
  TextEditingController emailController = TextEditingController();
  TextEditingController cepController = TextEditingController();
  TextEditingController adressController = TextEditingController();

  PartnerService service = new PartnerService();

  savePartner() {
    service.postPartner(Partner).then((data) => this.setState(() {}));
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: BodyCriarCliente(),
    );
  }

  Widget BodyCriarCliente() {
    return Container(
      width: MediaQuery.of(context).size.width,
      height: MediaQuery.of(context).size.height,
      child: Padding(
        padding: const EdgeInsets.only(top: 70, right: 25, left: 25),
        child: Column(
          children: [
            Text("Cadastro do Parceiro",
                style: TextStyle(fontSize: 24, fontWeight: FontWeight.bold)),
            Expanded(
                child: SingleChildScrollView(
              child: getColumn(),
            )),
            SizedBox(
              height: 30,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.end,
              children: [
                ElevatedButton(
                  onPressed: () {
                    back();
                  },
                  child: Text('Cancelar'),
                ),
                SizedBox(
                  width: 20,
                ),
                ElevatedButton(
                    onPressed: () {
                      createCliente();
                    },
                    child: Text('Criar')),
              ],
            ),
          ],
        ),
      ),
    );
  }

  Column getColumn() {
    List<Widget> list = [];

    list.add(SizedBox(
      height: 30,
    ));
    list.add(TextField(
      controller: nameController,
      decoration: InputDecoration(
        labelText: 'Nome da empresa',
        border: OutlineInputBorder(),
        helperText: 'Este nome aparecerá para os parceiros',
      ),
    ));
    list.add(SizedBox(
      height: 30,
    ));
    list.add(TextField(
      controller: CPFController,
      decoration: InputDecoration(
        labelText: 'CNPJ',
        border: OutlineInputBorder(),
      ),
      keyboardType: TextInputType.number,
    ));
    list.add(SizedBox(
      height: 30,
    ));
    list.add(TextField(
      controller: passwordController,
      decoration: InputDecoration(
        labelText: 'Senha',
        border: OutlineInputBorder(),
      ),
      keyboardType: TextInputType.visiblePassword,
    ));
    list.add(SizedBox(
      height: 30,
    ));
    //Usar o FileUploadInputElement() talvez para fazer upload de imagem
    list.add(TextField(
      controller: emailController,
      decoration: InputDecoration(
        labelText: 'Email',
        border: OutlineInputBorder(),
      ),
      keyboardType: TextInputType.emailAddress,
    ));
    list.add(SizedBox(
      height: 30,
    ));
    list.add(TextField(
        controller: cepController,
        decoration: InputDecoration(
          labelText: 'Cep',
          border: OutlineInputBorder(),
        ),
        keyboardType: TextInputType.number));
    list.add(SizedBox(
      height: 30,
    ));
    list.add(TextField(
      controller: adressController,
      decoration: InputDecoration(
        labelText: 'Endereço',
        border: OutlineInputBorder(),
      ),
    ));
    return new Column(children: list);
  }

  void createCliente() {
    var rng = new Random();
    int n = rng.nextInt(300) + 1;
    String url =
        "https://raw.githubusercontent.com/PokeAPI/sprites/master/sprites/pokemon/$n.png";
    print('url: ' + url);
    Partner = CreatePartner(url, CPFController.text, emailController.text,
        nameController.text, passwordController.text);

    savePartner();
    print("Parceiro cadastrado!");
    back();
  }

  void back() {
    Navigator.push(
        context, MaterialPageRoute(builder: (context) => LoginScreen()));
  }
}
