import 'dart:convert';

import 'package:apus_drones_mobile/assets/config.dart';
import 'package:apus_drones_mobile/models/CreateCustomer.dart';
import 'package:apus_drones_mobile/models/CustomerModel.dart';
import 'package:apus_drones_mobile/utils/httpHeaders.dart';

import 'package:http/http.dart' as http;

class CustomerService {
  Future<CustomerModel> getProfile() async {
    http.Response response = await http.get(
      Uri.parse('${Config.apiURL}/user/profile'),
      headers: await getHttpHeaders(),
    );
    var rsBody = json.decode(response.body);
    CustomerModel customer = CustomerModel.fromJson(rsBody);
    return customer;
  }

  Future<void> postCustomer(CreateCustomer customer) async {
    print(json.encode(customer.toJson()));
    try {
      http.Response response = await http.post(
          Uri.parse('${Config.apiURL}/customers'),
          headers: await getHttpHeaders(),
          body: json.encode(customer.toJson()));

      print(response);
    } catch (error) {
      print(error);
    }
  }
}
