import 'dart:convert';

import 'package:apus_drones_mobile/assets/config.dart';
import 'package:apus_drones_mobile/models/SearchModel.dart';
import 'package:apus_drones_mobile/utils/httpHeaders.dart';
import 'package:http/http.dart' as http;

class SearchService {
  Future<SearchModel> getSearch(String search) async {
    http.Response response = await http.get(
      Uri.parse('${Config.apiURL}/search/$search'),
      headers: await getHttpHeaders(),
    );
    var rsBody = json.decode(response.body);
    SearchModel s = SearchModel.fromJson(rsBody);
    return s;
  }
}
