import 'package:apus_drones_mobile/models/OrderItemModel.dart';
import 'package:apus_drones_mobile/models/PartnerOrderModel.dart';
import 'package:flutter/material.dart';

class CustomerOrderModal extends StatefulWidget {
  final PartnerOrderModel pom;
  final Function closed;
  const CustomerOrderModal(this.pom, this.closed);

  @override
  _CustomerOrderModalState createState() => _CustomerOrderModalState();
}

class _CustomerOrderModalState extends State<CustomerOrderModal> {

  void pressedButtonOK(BuildContext context) async {
       widget.closed();
       Navigator.pop(context);
  }


  @override
  Widget build(BuildContext context) {
     return Container(
      height: MediaQuery.of(context).size.height * 0.5,
      child: Center(
        child: Column(children: [
          Container(
            width: 150,
            child: Image.asset("lib/assets/icons/drone_icon.png"),
          ),
          Padding(
            padding: EdgeInsets.fromLTRB(0, 0, 0, 20),
            child: Text(
              "SEU PEDIDO ESTA EM COLETA!",
              style: TextStyle(fontSize: 24, fontWeight: FontWeight.bold),
            ),
          ),
          Expanded(
              child: SingleChildScrollView(
            child: getColumn(),
          )),
          Row(
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              ElevatedButton(
                  onPressed: () => {pressedButtonOK(context)},
                  child: Text("OK!",
                      style: TextStyle(fontSize: 20)),
                  style: ElevatedButton.styleFrom(minimumSize: Size(92, 36))),
                  ],
          )
        ]),
      ),
    );
  }

  Column getColumn() {
    List<Widget> list = [];
    list.add(Padding(
      padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
      child: Text('Local de entrega: ${widget.pom.deliveryAddress.description}',
          style: TextStyle(fontSize: 16)),
    ));
    list.add(Padding(
      padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
      child: Text('Número: ${widget.pom.deliveryAddress.number}',
          style: TextStyle(fontSize: 16)),
    ));
    list.add(Padding(
      padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
      child:
          Text('Peso: ${calculateWeight()} g', style: TextStyle(fontSize: 16)),
    ));
    list.add(Padding(
      padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
      child: Text('Valor do pedido: R\$ ${widget.pom.orderPrice}',
          style: TextStyle(fontSize: 16)),
    ));
    list.add(Padding(
      padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
      child: Text('Valor da entrega: R\$ ${widget.pom.deliveryPrice}',
          style: TextStyle(fontSize: 16)),
    ));
    list.add(Padding(
      padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
      child: Text(
          'Total: R\$ ${widget.pom.deliveryPrice + widget.pom.orderPrice}',
          style: TextStyle(fontSize: 16)),
    ));
    list.add(Padding(
      padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
      child: Text('Produtos: ', style: TextStyle(fontSize: 16)),
    ));

    for (var i = 0; i < widget.pom.items.length; i++) {
      list.add(
        Padding(
            padding: EdgeInsets.fromLTRB(0, 0, 0, 10),
            child: Text(
              widget.pom.items[i].quantity.toString() +
                  "x  " +
                  widget.pom.items[i].product.name,
              style: TextStyle(fontSize: 16),
            )),
      );
    }

    return new Column(children: list);
  }

  double calculateWeight() {
    double weight = 0;
    for (int i = 0; i < widget.pom.items.length; i++) {
      OrderItemModel o = widget.pom.items[i];
      weight += (o.quantity * o.product.weight);
    }
    return weight;
  }
}