import 'package:apus_drones_mobile/widgets/Price.dart';
import 'package:flutter/material.dart';

class Fee extends StatelessWidget {
  final double productsSumPrice;
  final double deliveryFee;
  final double totalPrice;

  Fee(
      {required this.productsSumPrice,
      required this.deliveryFee,
      required this.totalPrice});

  @override
  Widget build(BuildContext context) {
    return Container(
      width: double.infinity,
      margin: EdgeInsets.only(top: 25),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.center,
        children: [
          this._renderPrice(
              "Produtos: ", this.productsSumPrice, TextStyle(fontSize: 20)),
          this._renderPrice(
              "Frete: ", this.deliveryFee, TextStyle(fontSize: 20)),
          SizedBox(height: 15),
          this._renderPrice("Total: ", this.totalPrice,
              TextStyle(fontSize: 24, fontWeight: FontWeight.bold)),
        ],
      ),
    );
  }

  Widget _renderPrice(String prefix, double value, TextStyle style) {
    return Row(
      children: [Text(prefix, style: style), Price(price: value, style: style)],
      crossAxisAlignment: CrossAxisAlignment.center,
      mainAxisAlignment: MainAxisAlignment.center,
    );
  }
}
