import 'package:apus_drones_mobile/models/PartnerOrderModel.dart';
import 'package:apus_drones_mobile/screens/PartnerOrderDetailScreen.dart';
import 'package:apus_drones_mobile/widgets/Price.dart';
import 'package:apus_drones_mobile/widgets/StatusButton.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

class PartnerOrderCard extends StatelessWidget {
  final PartnerOrderModel model;
  const PartnerOrderCard({Key? key, required this.model}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Card(
      elevation: 3,
      margin: EdgeInsets.symmetric(horizontal: 14, vertical: 8),
      child: InkWell(
        onTap: () {
          Navigator.push(
              context,
              MaterialPageRoute(
                  builder: (context) =>
                      PartnerOrderDetailsScreen(id: model.id)));
        },
        child: Padding(
          padding: const EdgeInsets.all(16.0),
          child:
              Row(mainAxisAlignment: MainAxisAlignment.spaceBetween, children: [
            Container(
              padding: const EdgeInsets.only(top: 8.0),
              width: MediaQuery.of(context).size.width - 164,
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Padding(
                    padding: const EdgeInsets.only(bottom: 8.0),
                    child: Text(
                      this.model.customer.name,
                      style: TextStyle(fontSize: 16),
                    ),
                  ),
                  Column(
                    children: this
                        .model
                        .items
                        .map(
                          (item) => Text(
                            item.quantity.toString() + 'x ' + item.product.name,
                            style: TextStyle(color: Colors.grey.shade600),
                            overflow: TextOverflow.ellipsis,
                          ),
                        )
                        .toList(),
                    crossAxisAlignment: CrossAxisAlignment.start,
                  ),
                ],
              ),
            ),
            Column(
              mainAxisAlignment: MainAxisAlignment.end,
              children: [
                Text(DateFormat('dd/MM/yyyy').format(this.model.createdAt)),
                Price(price: this.model.orderPrice),
                Padding(
                  padding: const EdgeInsets.only(top: 8.0),
                  child: StatusButton(status: this.model.status),
                ),
              ],
            )
          ]),
        ),
      ),
    );
  }
}
